
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                       ; 
;simple activation model with reaction and counting task;
;                                                       ;
;                                                       ;
;                                                       ;
;do-subj runs all trials of all participants            ;
;do-id n m runs id n of participant m                   ;
;*curr-trial* shows the last presented trial            ;
;                                                       ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;
;in no counting:

;reaction task: retrieve if a letter is consonant or vowel and punch left or right index finger (1, 0) accordingly
;diagnosis task: collect symptoms in imgaginal and retrieve the most active diagnosis in the end (symptoms in imaginal spread activation)

;;;;;;;;;;;;;;;;;;;
;in counting:

;reaction task: retrieve if a letter is consonant or vowel and punch left or right index finger (1, 0) accordingly

;counting task: when punching the key for the reaction task, check if there is a count-from fact in the imaginal - if not, restore one from dm
;;;if letter was a vowel, nothing is done with the restored count fact
;;;if letter is consonant, after resoring count-from fact, retrieve a count fact from dm and increment the count-from fact in the imaginal

;diagnosis task: when observing a symptom, put this symptom in the imaginal - throw out the currect count fact from the imaginal
;restore previous symptoms from dm and add them to the imaginal
;retrieve the most active diagnosis in the end (symptoms in imaginal spread activation) - but as potentially not all symptoms were observed, sa can be suboptimal


;;;;;;;;;;;;;;;;;;;;
;to restore previous problem-states, the model uses activation spreading from an id-slot in the goal buffer (the number of slots in the goal is always 4, so that the fan is always equal)
; uses unique ids for problem-state chunks by combining id and trialnumber

;in the count condition, the model always uses a count-from fact -> also after only vowels were heard will the model have to restore symptoms from dm
;the model keeps stuff in the imaginal, as long as something new is put into it


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun re () (run-environment))

;;;;;;;;;;;;;;;;;;;;;;;;;Running Code Parameters;;;;;;;;;;;;;;;;;;;;;;;;;

(defparameter *curr-stim* nil)             ;paramters that hold the stimuli
(defparameter *curr-sound-stim* nil)
(defparameter *curr-trial* nil)
(defparameter *cheat-trial* nil)
(defparameter *trial-list* nil)
(defparameter *task* nil)
(defparameter *taskid* nil)
(defparameter *counter* 0)
(defparameter *sympid* nil)
(defparameter *sympcounter* 0)
(defparameter *VP* 0)
(defparameter *trials* 0)
(defparameter *trials-vp* 0)

(defparameter *complete-exp* nil)   ;parameter that is used to switch on and off what is orinted in the listener during run (on: write ou which audio letters are presented)

(defparameter *trial-num* 0)              ;parameters that are saved for output
(defparameter *subj-nr* 0)
(defparameter *idm* 0)
(defparameter *block* 0)
(defparameter *run* 0)

(defparameter *start-t-diag* nil)
(defparameter *stop-t-diag* nil)
(defparameter *diag-rt* nil)
(defparameter *diag-resp* nil)

(defparameter *start-t-count* nil)
(defparameter *stop-t-count* nil)
(defparameter *count-rt* nil)
(defparameter *count-resp* nil)
(defparameter *done* nil)

(defparameter *start-t-react* nil)
(defparameter *stop-t-react* nil)
(defparameter *react-resp1* nil)
(defparameter *react-resp2* nil)
(defparameter *react-resp3* nil)
(defparameter *react-resp4* nil)
(defparameter *react-resp5* nil)
(defparameter *react-resp6* nil)
(defparameter *react-resp7* nil)
(defparameter *react-resp8* nil)
(defparameter *react-resp9* nil)
(defparameter *react-resp10* nil)
(defparameter *react-resp11* nil)
(defparameter *react-resp12* nil)
(defparameter *react-resp13* nil)
(defparameter *react-resp14* nil)
(defparameter *react-rt1* nil)
(defparameter *react-rt2* nil)
(defparameter *react-rt3* nil)
(defparameter *react-rt4* nil)
(defparameter *react-rt5* nil)
(defparameter *react-rt6* nil)
(defparameter *react-rt7* nil)
(defparameter *react-rt8* nil)
(defparameter *react-rt9* nil)
(defparameter *react-rt10* nil)
(defparameter *react-rt11* nil)
(defparameter *react-rt12* nil)
(defparameter *react-rt13* nil)
(defparameter *react-rt14* nil)
(defparameter *react-done* nil)


;;;;;;;;;;;;;;;;;;;;;;;;;Output Code - Parameters;;;;;;;;;;;;;;;;;;;;;;;;;
(defparameter *read-write-path* (current-pathname))
(defparameter *results* nil)



;;;;;;; 
;does one trial of one vp - done


(defun do-id (id vp)  

  (setf *complete-exp* nil)  

  (reset)         

  (setf *results* nil)
  (setf *vp* 0)


  (read-file)                                ;reads in the file containing all trials

  (setf *trial-num* 0)

  (dolist (trial (nth (- vp 1) *trial-list*))       ;gets the trials of the nth subject from the trial-list
    (when (= (third (reverse trial)) id) 
      (setf *curr-trial* trial)))

  (setf *idm* (third (reverse *curr-trial*)))

  (do-trial *curr-trial*)                       ;calls do-trial with the specified trial

)



;;;;;;;;;;;
;does all trials of all vpn

(defun do-exp ()

  (read-file)

  (setf *results* nil)
  (setf *vp* 0)
  (setf *idm* 0)

  (dotimes (i (first (reverse (first (first (reverse *trial-list*))))))   ;number of VPn

              (setf *trials* (pop *trial-list*))  ;takes the trials of one vp and puts them in the list *trials*

              (do-vp (first (reverse (first *trials*)))))     ;calls do-vp for first vp in the remaining list

  (write-file-res)

)


(defun do-many (j)

  (setf *complete-exp* t)  ; so that in the scheduling function I can change the output in the listener depending on that 

  (setf *results* nil)
  (setf *vp* 0)
  (setf *run* 0)

  (dotimes (k j)

  (read-file)

  (setf *idm* 0)
  (setf *run* (+ *run* 1))

  (dotimes (i (first (reverse (first (first (reverse *trial-list*))))))   ;number of VPn

              (setf *trials* (pop *trial-list*))  ;takes the trials of one vp and puts them in the list *trials*

              (do-vp (first (reverse (first *trials*))))))     ;calls do-vp for vp in the list
  
  (write-file-res)
)

;;;;;;
;does one vp - is called by do exp
(defun do-vp (vp)

  (dolist (i *trials*)

    (reset)                                ;reset

    (setf *vp* vp)
    (setf *idm* (+ *idm* 1))
    
    (do-trial (setf *curr-trial* i)))       ;calls do-trial for each trial

)


;;;;;;;;;
;do trial - is called by do-id and by do-vp and do-id

(defun do-trial (trial)

;reset per trial
  (reset) 
           
;reset per block - ;modulo operator returns 0 when the id number -1  can be devided by 9 - that resets the model after every 9 trials
 ;(if (equalp 0 (mod (- *idm* 1) 9)) (reset))    

  (setf *task* nil) 
  (setf *taskid* nil) 
  (setf *done* nil) 
  (setf *counter* 0)          ;counts up the sound displays - needed for id
  (setf *sympcounter* 0)      ;counts up the symptoms  - needed for sympid

  (setf *start-t-count* nil)
  (setf *stop-t-count* nil)
  (setf *count-rt* nil)
  (setf *count-resp* nil)

 (setf *cheat-trial* trial)   ;so that one by one the trials can be gotten out of the list in display next
  
  (let ((window (open-exp-window "Diagnosis Experiment" :visible nil)))
    (install-device window)

    ;sets 1st goal focus to diag
    (if (equalp (fifth (reverse trial)) 'zero)   ;goal focus to count or no-count, depending on type of trial ((threads-pprint) to check it)
        (goal-focus diag-goal-nocount) 
        (goal-focus diag-goal-count)) 

       (add-dm (isa previoussymptom id s0))  ;puts a diag chunk without symptoms and with sympid s0 in the dm

    ;sets 2nd goal focus to count
    (if (equalp (fifth (reverse trial)) 'zero)   ;goal focus to count or no-count, depending on type of trial ((threads-pprint) to check if it worked)
        (goal-focus react-goal-nocount) 
        (goal-focus react-goal-count)) 

   (if (equalp (fifth (reverse trial)) 'count)   ;puts a count chunk with count 0 and with id r0 in the dm
        (add-dm (isa count-from count 0  id r0)))


    ;schedule all stimuli

    (dotimes (i 4)                                        ;schedule 4 sound displays before first symptom (every display takes 2 seconds)
      (schedule-event-relative (* i 2) 'display-next-sound))    ;at 0, 2, 4, 6,

                                                          ;schedule 1. symptom display, 1.5 sec after onset of previous sound (takes 2 seconds)
      (schedule-event-relative 7.5 'display-next-word)                ;at 7.5         
      (schedule-event-relative 9.5  'clear-exp-window)                ;clear the screen after the symp was on there for 2 sec

    (dotimes (i 3)                                        ;schedule 3 sound displays starting .5 seconds after symptom (every 2.5 seconds)
      (schedule-event-relative (+ 8 (* i 2)) 'display-next-sound))   ;at 8, 10, 12
   
                                                          ;schedule 2. symptom display
      (schedule-event-relative 13.5 'display-next-word)                 ;at 13.5
      (schedule-event-relative 15.5 'clear-exp-window)

    (dotimes (i 3)                                        ;schedule 3 sound displays 
      (schedule-event-relative (+ 14 (* i 2)) 'display-next-sound))  ;at 14, 16, 18      

                                                         ;schedule 3. symptom display
      (schedule-event-relative 19.5 'display-next-word)
      (schedule-event-relative 21.5 'clear-exp-window)                            

    (dotimes (i 3)                                        ;schedule 3 sound displays 
      (schedule-event-relative (+ 20 (* i 2)) 'display-next-sound))     ;at 20,22,24

                                                         ;schedule 4. symptom display
      (schedule-event-relative 25.5 'display-next-word)                 ;at 25.5      
      (schedule-event-relative 27.5 'clear-exp-window)              

                                             ;schedule last sound display 
      (schedule-event-relative 26 'display-next-sound)       ;at 26

                                            ;schedule diagnosis question 2 seconds after last sound display
      (schedule-event-relative 28 'display-next-word)         ;at 28

   ;only schedule the count in the count condition - otherwise the model doesn't schedule right if it isn't reset    
      (if (equalp (fifth (reverse trial)) 'count)                 
       (schedule-event-relative 32 'display-next-word))      ;at 32 it schedules the count display 
  
     (run-until-condition (lambda () *done*) :real-time nil) 
                       
     )                              

  (save-results-acc)

)

;presents the sound stimuli that were scheduled above

(defun display-next-sound ()

  ;set *curr-sound-stim* to the current to-be-displayed stimulus  
  (setf *curr-sound-stim* (format nil "~a" (first *cheat-trial*)))

  ;define the variables duration, delay and recode
    (let*
        ((duration (get-articulation-time *curr-sound-stim*))
         (delay (rand-time (digit-detect-delay (get-module :audio))))
         (recode (ms-round (max
                       (/ duration 2)
                       (- duration 0.150)))))
 
    ;display the sound stim, using the defined variables duration, delay and recode (necessary to present the letter as a non-string that spreads activation)
    (new-other-sound (pop *cheat-trial*) duration delay recode))

      (if (not *complete-exp*)                                 ;if it doesn't run do-many
          (format t "Producing word ~S~%" *curr-sound-stim*))  ;writes stuff into listener ~% makes new line ~S inserts string that is defined behind it
      
      (setf *start-t-react* (mp-time))

      (incf *counter*)           ;increases counter by one (was set to zero at start in do trial)  - needed for the id (retrieval of previous count-from)
      
      (when (= *counter* 1) 
          (setf *task* "react1")) 

      (when (= *counter* 2) 
          (setf *task* "react2"))

      (when (= *counter* 3) 
          (setf *task* "react3"))

      (when (= *counter* 4) 
          (setf *task* "react4"))

      (when (= *counter* 5) 
          (setf *task* "react5"))

      (when (= *counter* 6) 
          (setf *task* "react6"))

      (when (= *counter* 7) 
          (setf *task* "react7"))

      (when (= *counter* 8) 
          (setf *task* "react8"))

      (when (= *counter* 9) 
          (setf *task* "react9"))
      
      (when (= *counter* 10) 
          (setf *task* "react10"))
      
      (when (= *counter* 11) 
          (setf *task* "react11"))
      
      (when (= *counter* 12) 
          (setf *task* "react12"))
      
      (when (= *counter* 13) 
          (setf *task* "react13"))
      
      (when (= *counter* 14) 
          (setf *task* "react14"))
      
      (proc-display)
)

;presents the text stimuli that were scheduled above

(defun display-next-word ()
 
  (clear-exp-window)
      
 (add-text-to-exp-window :text (setf *curr-stim* (format nil "~a" (pop *cheat-trial*))) :x 50 :y 150)

      (incf *sympcounter*)           ;increases sympcounter by one (was set to zero at start in do trial) - needed for the sympid (retrieval of previoussymptoms)
      
      (when (equalp *curr-stim* "diagnose")
        (setf *start-t-diag* (mp-time))
        (setf *task* "diag")
        )
      
      (when (equalp *curr-stim* "anzahl")
        (setf *start-t-count* (mp-time))
        (setf *task* "count")
        )
  
      (proc-display)
)

;collects the models responses

(defmethod rpm-window-key-event-handler ((win rpm-window) key)

  (when (equalp *task* "react1")
    (setf *react-resp1* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt1* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react2")
    (setf *react-resp2* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt2* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react3")
    (setf *react-resp3* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt3* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react4")
    (setf *react-resp4* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt4* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react5")
    (setf *react-resp5* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt5* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react6")
    (setf *react-resp6* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt6* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react7")
    (setf *react-resp7* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt7* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react8")
    (setf *react-resp8* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt8* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react9")
    (setf *react-resp9* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt9* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react10")
    (setf *react-resp10* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt10* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react11")
    (setf *react-resp11* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt11* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react12")
    (setf *react-resp12* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt12* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react13")
    (setf *react-resp13* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt13* (- *stop-t-react* *start-t-react*)))

  (when (equalp *task* "react14")
    (setf *react-resp14* (string-upcase (string key)))
    (setf *stop-t-react* (mp-time))
    (setf *react-done* t)
    (setf *react-rt14* (- *stop-t-react* *start-t-react*)))

  (when (and (equalp *task* "diag") (equalp (fifth (reverse *curr-trial*)) 'count))
    (setf *diag-resp* (string-upcase (string key)))
    (setf *stop-t-diag* (mp-time))
 ;   (setf *done* t)    ;do not set done to t, because in this condition you still want to show the count-question
    (setf *diag-rt* (- *stop-t-diag* *start-t-diag*)))
 
 (when (and (equalp *task* "diag") (equalp (fifth (reverse *curr-trial*)) 'zero))
    (setf *diag-resp* (string-upcase (string key)))
    (setf *stop-t-diag* (mp-time))
    (setf *done* t)    ;do set done to t, because in this condition we are done now
    (setf *diag-rt* (- *stop-t-diag* *start-t-diag*)))


 (when (and (equalp *task* "count") (or (not (equalp "X" (string-upcase (string key)))) (not (equalp "Y" (string-upcase (string key)))) (not (equalp "Z" (string-upcase (string key)))))) 
    (setf *count-resp* (string-upcase (string key)))
    (setf *stop-t-count* (mp-time))
    (setf *done* t)
    (setf *count-rt* (- *stop-t-count* *start-t-count*))
    )

 (when (and (equalp *task* "count") (equalp "X" (string-upcase (string key))))
    (setf *count-resp* "10")  
    (setf *stop-t-count* (mp-time))
    (setf *done* t)
    (setf *count-rt* (- *stop-t-count* *start-t-count*))
    )

 (when (and (equalp *task* "count") (equalp "Y" (string-upcase (string key))))
    (setf *count-resp* "11")  
    (setf *stop-t-count* (mp-time))
    (setf *done* t)
    (setf *count-rt* (- *stop-t-count* *start-t-count*))
    )
 (when (and (equalp *task* "count") (equalp "Z" (string-upcase (string key))))
    (setf *count-resp* "12")  
    (setf *stop-t-count* (mp-time))
    (setf *done* t)
    (setf *count-rt* (- *stop-t-count* *start-t-count*))
    )

)


;puts the current trial, including the models response in the list *results*

(defun save-results-acc ()

  (push (list *run* *vp* *block* *idm* (third (reverse *curr-trial*)) (fourth (reverse *curr-trial*)) (fifth (reverse *curr-trial*))
              (fifth *curr-trial*) (nth 8 *curr-trial*) (nth 12 *curr-trial*) (nth 16 *curr-trial*)
              (sixth (reverse *curr-trial*)) *diag-resp* *diag-rt*  
              (nth 6 (reverse *curr-trial*)) *count-resp* *count-rt*
              (nth 20 *curr-trial*) (nth 21 *curr-trial*) (nth 22 *curr-trial*)
              (first *curr-trial*) (nth 7 (reverse *curr-trial*)) *react-resp1* *react-rt1*
              (second *curr-trial*) (nth 8 (reverse *curr-trial*)) *react-resp2* *react-rt2*            
              (third *curr-trial*) (nth 9 (reverse *curr-trial*)) *react-resp3* *react-rt3*
              (fourth *curr-trial*) (nth 10 (reverse *curr-trial*)) *react-resp4* *react-rt4*
              (nth 5 *curr-trial*) (nth 11 (reverse *curr-trial*)) *react-resp5* *react-rt5*
              (nth 6 *curr-trial*) (nth 12 (reverse *curr-trial*)) *react-resp6* *react-rt6*
              (nth 7 *curr-trial*) (nth 13 (reverse *curr-trial*)) *react-resp7* *react-rt7*
              (nth 9 *curr-trial*) (nth 14 (reverse *curr-trial*)) *react-resp8* *react-rt8*
              (nth 10 *curr-trial*) (nth 15 (reverse *curr-trial*)) *react-resp9* *react-rt9*
              (nth 11 *curr-trial*) (nth 16 (reverse *curr-trial*)) *react-resp10* *react-rt10*
              (nth 13 *curr-trial*) (nth 17 (reverse *curr-trial*)) *react-resp11* *react-rt11*
              (nth 14 *curr-trial*) (nth 18 (reverse *curr-trial*)) *react-resp12* *react-rt12*
              (nth 15 *curr-trial*) (nth 19 (reverse *curr-trial*)) *react-resp13* *react-rt13*
              (nth 17 *curr-trial*) (nth 20 (reverse *curr-trial*)) *react-resp14* *react-rt14*)*results*)

)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; input 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,
;trials
; read in trials as presented to participants 

(defun read-file ()
  (with-open-file (in (merge-pathnames 
                       (make-pathname :name "trials_implicit_080911" :directory '(:relative "input") :type "txt")  
                       *read-write-path*)
                      :direction :input)
    (do ((trial-lis nil (cons trial trial-lis))
         (trial (read in nil 'end) (read in nil 'end)))
        ((equal trial 'end) (setf *trial-list* (reverse trial-lis))))
    )
 
  (restruc *trial-list*)

)


;puts all trials of one participant in a seperate list - done
(defun restruc (trial-lis)

 (let ((newlis) (trial) (act-vp 0))

  (dotimes (i (first (last (first (last *trial-list*)))) newlis) 
    (setf newlis (cons nil newlis)))

  (dotimes (j (length trial-lis) newlis)
    (setf trial (nth j trial-lis))
    (cond 
     ((= (first (last trial)) (+ act-vp 1)) (setf (nth act-vp newlis) (cons trial (nth act-vp newlis))))
     ((not (= (first (last trial)) (+ act-vp 1)))
      (progn 
        (setf (nth act-vp newlis) (reverse (nth act-vp newlis)))
        (incf act-vp)
        (setf (nth act-vp newlis) (cons trial (nth act-vp newlis))))) )
    )

  (setf (first (last newlis)) (reverse (first (last newlis))))
  (setf *trial-list* newlis))

)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; output 


(defun write-file-res ()
  (with-open-file (out (ensure-directories-exist 
                        (merge-pathnames
                         (make-pathname :name "model_pbr_aural_paper_20" :directory '(:relative "output") :type "dat")  
                         *read-write-path*))
                       :direction :output :if-does-not-exist :create :if-exists :supersede)
    (setf *results* (reverse *results*))
    (push (list 'run 'VP 'block 'id_model 'id 'target 'condition 'symptom1 ' symptom2 'symptom3 'symptom4 'diag.CRESP 'diag.RESP_model 'diag.RT_model 
                'count.CRESP 'count.RESP_model 'count.RT_model 'prime.trial 'N.prime 'last
                'Stimulus1 'react.CRESP.1  'react.RESP_model.1 'react.RT_model.1
                'Stimulus2 'react.CRESP.2  'react.RESP_model.2 'react.RT_model.2
                'Stimulus3 'react.CRESP.3  'react.RESP_model.3 'react.RT_model.3
                'Stimulus4 'react.CRESP.4  'react.RESP_model.4 'react.RT_model.4
                'Stimulus5 'react.CRESP.5  'react.RESP_model.5 'react.RT_model.5
                'Stimulus6 'react.CRESP.6  'react.RESP_model.6 'react.RT_model.6
                'Stimulus7 'react.CRESP.7  'react.RESP_model.7 'react.RT_model.7
                'Stimulus8 'react.CRESP.8  'react.RESP_model.8 'react.RT_model.8
                'Stimulus9 'react.CRESP.9  'react.RESP_model.9 'react.RT_model.9
                'Stimulus10 'react.CRESP.10  'react.RESP_model.10 'react.RT_model.10
                'Stimulus11 'react.CRESP.11  'react.RESP_model.11 'react.RT_model.11
                'Stimulus12 'react.CRESP.12  'react.RESP_model.12 'react.RT_model.12
                'Stimulus13 'react.CRESP.13  'react.RESP_model.13 'react.RT_model.13
                'Stimulus14 'react.CRESP.14  'react.RESP_model.14 'react.RT_model.14) *results*)

    (dolist (line *results*)
      (format out "~{~a~t~}~%" line))
))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;ACT-R Model Code;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun new-w (buffer slot)
  (if (eq buffer 'imaginal )    
    (case slot
      (s1 .12)
      (s2 .12)
      (s3 .12)
      (s4 .12)
      (t nil))
   )
)



(clear-all)

(define-model Katja_dual

(sgp 
:esc t                     ;enables subsymbolic computations
:trace-detail low :v nil     ;enables buffer trace
:act nil                     ;enables activation trace
:show-focus nil            ;shows focus of attention

:bll .5                    ;enables base-level learning and sets decay parameter to 0.5
:ol 8                      ;nil: disables optimized learning; 8 = number of references for which bll is used, the rest uses optimized learning
:rt -3                     ;set retrieval threshold
:lf .3                     ;decreased from original model   ;decreases latency (with .1 retrievals are 10 times as fast

:GA 1.7                    ;overwrites default goal-activation (results in a w of .425 for the id chunks - as at retrieval there are 4 chunks in the goal)
:AURAL-ACTIVATION .75      ;overwrites the default aural activation (results in a w of .25 for the audio stim chunks - as at retrieval there are 3 chunks in the aural)
:IMAGINAL-ACTIVATION  1    ;is overwritten by w-hook, but needs to be set to a value to spread anything
:w-hook new-w              ;calls the function new-w defined above to set the w of each of the 4 symptoms to .12

:MAS 2.5                   ;enables spreading activation and sets maximum spreading activation (S) = 2.5 
                                           ;(sji (association from source j to chunk i): = S - ln (fanji))
                                           ;fanji (number of chunks i in which j appears)

:er t                      ;if several chunks have same activation, choice is made randomly
;:mp 1.0                   ;enables parial matching - switched off, as pm and sa shouldn't used together in one model
:ans 0.11                  ;enables transient noice adn sets s to .11 (is computed with each retrieval request)

:DELETE-VISICON-CHUNKS t     ;required settings for the visual module
:visual-movement-tolerance 10

:save-buffer-trace t
)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; declarative memory ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;chunk-types

;;;;;;for the diagnosis task
(chunk-type association name value s1 s2 s3 s4 type class) ;stores letters and associated symptoms in dm (stores 4 symptoms, if it is a consonant or vowel and if it is a chemical)
(chunk-type word value type)                               ; e.g. for symptoms (stores the name and that it is a symptom)

(chunk-type diagnose state diag-state count id)            ;for the goal buffer (stores state, diag-state, and id) *new: aslo has a count slot ;*new* add a slot for the trial-number- otherwise chunks from different trials merge
(chunk-type previoussymptom s1 s2 s3 s4 id)                ;for the imaginal (stores letters, up to 4 symptoms and id)

;;;;;;for the react and counting task
(chunk-type count-order first second)          ;stores count-facts in dm (a nunmber and its successor)

(chunk-type react state count-state count id)  ;for the goal buffer (stores state, count-state, count (yes, no) and id)
(chunk-type count-from count id)               ;for the imaginal (stores current count and id)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; chunks 

(add-dm 

;chunks for control states

(detect isa chunk)
(attend isa chunk)
(encode isa chunk)
(start isa chunk)
(retrieve isa chunk)
(end isa chunk)
(respond isa chunk)
(done isa chunk)
(retrieve-probe isa chunk)
(respond-to-probe isa chunk)

(yes isa chunk)
(no isa chunk)
(symptom isa chunk)
(consonant isa chunk)
(vowel isa chunk)
(chemical isa chunk)

(restore-count isa chunk)
(restore-count-vowel isa chunk)
(increment-count isa chunk)
(restore-diag isa chunk)
(retrieve-diag isa chunk)

(s0 isa chunk)
(r0 isa chunk)
(none isa chunk)


;for the goals
 
;set the appropriate goal at start of trial, depending on the condition (count or no count) - set in lisp code above
;in dm there is a count and a no count option for tasks, this allows the number of slots to be equal -> otherwise the w would be higher in diag than in count goals
(diag-goal-count isa diagnose state start diag-state start count yes id s0)           ;initiates diag goal for count and sets first id to s0
(diag-goal-nocount isa diagnose state start diag-state start count no id s0)          ;initiates diag goal for nocount and sets first id to s0

(react-goal-count isa react state start count-state start count yes id r0)    ;initiates count goal and sets first id to r0
(react-goal-nocount isa react state start count no id r0)                            ;initiates no-count goal for condition zero and sets first id to r0

;word facts for instructions

(diagnose isa word value "diagnose")
(anzahl isa word value "anzahl")

;for the counting task - count-order facts - from 0 to 20

 (count-one ISA count-order first 0 second 1)  
 (count-two ISA count-order first 1 second 2)
 (count-three ISA count-order first 2 second 3)
 (count-four ISA count-order first 3 second 4)
 (count-five ISA count-order first 4 second 5)
 (count-six ISA count-order first 5 second 6)
 (count-seven ISA count-order first 6 second 7)
 (count-eigth ISA count-order first 7 second 8)
 (count-nine ISA count-order first 8 second 9)
 (count-ten ISA count-order first 9 second 10)     
 (count-eleven ISA count-order first 10 second 11)
 (count-twelve ISA count-order first 11 second 12)
(count-thirteen ISA count-order first 12 second 13)
 (count-fourteen ISA count-order first 13 second 14)
 (count-fifteen ISA count-order first 14 second 15)
 (count-sixteen ISA count-order first 15 second 16)
 (count-seventeen ISA count-order first 16 second 17)
 (count-eighteen ISA count-order first 17 second 18)     
 (count-nineteen ISA count-order first 18 second 19)
 (count-twenty ISA count-order first 19 second 20)

;for the diagnosis task: word facts for symptoms

;specific for BTW
(Husten isa word value "Husten" type symptom)              
(Niesen isa word value "Niesen" type symptom)
(Atemnot isa word value "Atemnot" type symptom)
;specific for LHG
(Hautroetung isa word value "Hautroetung" type symptom)
(Juckreiz isa word value "Juckreiz" type symptom)
(Ausschlag isa word value "Ausschlag" type symptom)
;specific for CMR
(Durchfall isa word value "Durchfall" type symptom) 
(Erbrechen isa word value "Erbrechen" type symptom)  
(Kraempfe isa word value "Kraempfe" type symptom) 
;unspecific
(Kopfschmerzen isa word value "Kopfschmerzen" type symptom)  
(Fieber isa word value "Fieber" type symptom)  
(Schwindel isa word value "Schwindel" type symptom)
 
;for the diagnosis and reaction task: associaton facts for letters (and associated symptoms)

;consonants
(S isa association value S type consonant)
(K isa association value K type consonant)
(Q isa association value Q type consonant)
(F isa association value F type consonant)
(V isa association value V type consonant)
(D isa association value D type consonant)
(N isa association value N type consonant)
(P isa association value P type consonant)

;vowels
(u-umlaut isa association value u-umlaut type vowel)  ;no key mappings for those - no problem: as model is only allowed to retrieve/enter chemical letters for diagnosis
(a-umlaut isa association value a-umlaut type vowel)
(o-umlaut isa association value o-umlaut type vowel)
(A isa association value A type vowel)
(E isa association value E type vowel)
(I isa association value I type vowel)
(O isa association value O type vowel)
(U isa association value U type vowel)

; chemicals 
(B isa association value B s1 Husten s2 Atemnot s3 Kopfschmerzen s4 Schwindel type consonant class chemical)
(T isa association value T s1 Husten s2 Niesen s3 Kopfschmerzen s4 Fieber type consonant class chemical)  
(W isa association value W s1 Niesen s2 Atemnot s3 Fieber s4 Schwindel type consonant class chemical)

(L isa association value L s1 Hautroetung s2 Ausschlag s3 Kopfschmerzen s4 Schwindel type consonant class chemical)
(H isa association value H s1 Hautroetung s2 Juckreiz s3 Kopfschmerzen s4 Fieber type consonant class chemical)
(G isa association value G s1 Juckreiz s2 Ausschlag s3 Fieber s4 Schwindel type consonant class chemical)

(C isa association value C s1 Durchfall s2 Kraempfe s3 Kopfschmerzen s4 Schwindel type consonant class chemical)
(M isa association value M s1 Durchfall s2 Erbrechen s3 Kopfschmerzen s4 Fieber type consonant class chemical)
(R isa association value R s1 Erbrechen s2 Kraempfe s3 Fieber s4 Schwindel type consonant class chemical)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;additional settings

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;set sjis 
;they are set to fixed values to avoid that they change over the trial, if the fan changes
;set them to the value that ACT-R would calculate for them at beginning of trial, if they were not set:

;unspecific: 0.5540899

(add-sji (Kopfschmerzen B 0.5540899))
(add-sji (Kopfschmerzen T 0.5540899))
(add-sji (Kopfschmerzen L 0.5540899))
(add-sji (Kopfschmerzen H 0.5540899))
(add-sji (Kopfschmerzen C 0.5540899))
(add-sji (Kopfschmerzen M 0.5540899))

(add-sji (Schwindel B 0.5540899))
(add-sji (Schwindel W 0.5540899))
(add-sji (Schwindel L 0.5540899))
(add-sji (Schwindel G 0.5540899))
(add-sji (Schwindel C 0.5540899))
(add-sji (Schwindel R 0.5540899))

(add-sji (Fieber T 0.5540899))
(add-sji (Fieber W 0.5540899))
(add-sji (Fieber H 0.5540899))
(add-sji (Fieber G 0.5540899))
(add-sji (Fieber M 0.5540899))
(add-sji (Fieber R 0.5540899))

;specific: 1.4013877

(add-sji (Husten B 1.4013877))
(add-sji (Husten T 1.4013877))

(add-sji (Atemnot B 1.4013877))
(add-sji (Atemnot W 1.4013877))

(add-sji (Niesen T 1.4013877))
(add-sji (Niesen W 1.4013877))


(add-sji (Hautroetung L 1.4013877))
(add-sji (Hautroetung H 1.4013877))

(add-sji (Ausschlag L 1.4013877))
(add-sji (Ausschlag G 1.4013877))

(add-sji (Juckreiz H 1.4013877))
(add-sji (Juckreiz G 1.4013877))


(add-sji (Durchfall C 1.4013877))
(add-sji (Durchfall M 1.4013877))

(add-sji (Kraempfe C 1.4013877))
(add-sji (Kraempfe R 1.4013877))

(add-sji (Erbrechen M 1.4013877))
(add-sji (Erbrechen R 1.4013877))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;set base-levels

;results in: base level of 1.38
(sdp-fct (list (no-output (sdm isa word)) :creation-time -1e12 :reference-count 2000000))  
(sdp-fct (list (no-output (sdm isa association)) :creation-time -1e12 :reference-count 2000000))
(sdp-fct (list (no-output (sdm isa count-order)) :creation-time -1e12 :reference-count 2000000))  


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;preset the location of index fingers to reaction keys 0 and 1 at beginning of trial

; for entering the reaction to audio letters, hands are placed on the appropriate keys at beginning of the trial and then a punch is used 
;;;(as pps were instructed to leave their hands on the keys)

(set-hand-location left 1 2)   ;left index finger at 1
(set-hand-location right 10 2) ;right index finger at 0

;befor entering the count and the diagnoses, hands are placed down to the home row (set in production rules below) and from there a press-key is used
;;;(as pps don't know before which key they will have to press)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; procedural memory;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;   REACTION AND COUNTING TASK                           ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;   attend aural stimulus        ;;;;;;;;;;;;;;;;;;;;;;

;move attention to aural stimulus
(p attend-aural
   =goal>
     isa       react
     state     start
   =aural-location>
     isa       audio-event
     kind      speech
   ?aural>
     state     free
==>
   +aural>
     isa      sound
     event    =aural-location
)

;if the aural stimulus is none, set state to start again (for trials where there were no aural stimuli in the first 1 or 2 subtrials)
(p audio-none
  =goal>
    isa      react
    state    start
   =aural>
     isa     sound
     content none
==>
  =goal>
    state start
)

;if the aural stimulus is not none, try to retrieve it from dm
(p lexical-access
  =goal>
    isa      react
    state    start
   =aural>
     isa     sound
     content =string
     - content none
  ?retrieval>
    state    free
==>
   =aural>               ;keep it in the aural, so that the aural can spread activation 
  +retrieval>
    isa      association
  =goal>
    state respond
)


;;;;;;;;;;;;;;;;;;;;;   react (and in counting condition: count)  ;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; no count

;;;;;;;;;;;;
;reaction task vowel 

;if you retrieve that the audio stimulus is a vowel, press 1 
(p react-no-zero
  =goal>
     ISA         react
     state       respond
     count       no
  =retrieval>
     isa         association
     type        vowel
   ?manual>   
      state       free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state       start
   +manual>
      ISA         punch
      hand        left
      finger      index
   +visual>
    isa clear
)

;;;;;;;;;;;;
;reaction task consonant 

;if the goal state of count is no and you retrieve that the audio stimulus is a consonant, press 0  
(p react-yes-zero
  =goal>
     ISA         react
     state       respond
     count       no
  =retrieval>
     isa         association
     type        consonant
   ?manual>   
      state       free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state       start
   +manual>
      ISA         punch
      hand        right 
      finger      index
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; count

;;;;;;;;;;;;
;reaction task vowel - react to vowel and restore the count-from in the imaginal, if it isn't there at this point

;if you retrieved that the audio stimulus is a vowel, and the imaginal is empty, press 1 and retrieve a count-from fact
(p react-no-noimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
     id          =id   
  =retrieval>
     isa         association
     type        vowel
   ?manual>   
      state       free
  ?imaginal>
      state       free
      buffer      empty
  ?retrieval>
    state    free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    restore-count-vowel     ; use the count-state slot to mark where you are in the counting
  +retrieval>
     ISA         count-from
   +manual>
      ISA         punch
      hand        left 
      finger      index
)

;if you retrieved that the audio stimulus is a vowel, and the imaginal has a previous-symp fact, press 1 and retrieve a count from-fact
(p react-no-wrongimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
     id          =id   
  =retrieval>
     isa         association
     type        vowel
   ?manual>   
      state       free
  =imaginal>
     isa         previoussymptom
  ?retrieval>
    state    free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =imaginal>                         ;keep imaginal, till it is overwritten by the new content
  =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    restore-count-vowel     ; use the count-state slot to mark where you are in the counting
  +retrieval>
     ISA         count-from
   +manual>
      ISA         punch
      hand        left 
      finger      index
)

; if you can retrieve a count-from fact, restore it in the imaginal
(p restore-count-vowel
  =goal>
     ISA           react
     count-state   restore-count-vowel    ;if the count-state slot marks that you try to restore the count
  =retrieval>
      ISA         count-from
      count       =num1
  ?imaginal>
     state        free
  ?retrieval>
    state    free
==>
  !bind! =stringid (intern (format nil "~a~a" *counter* *idm*))    ;generate a unique id
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    increment-count    ;use the count-state slot to mark where you are in the counting
     id             =stringid             ;save the id of the count-from chunk also in the goal, so that you can use it to retrieve the right PS later
  +imaginal>
     ISA         count-from
     count       =num1 
     id          =stringid
)

;if you retrieved that the audio stimulus is a vowel, and there is a count from fact in the imaginal, press 1 
(p react-no-countimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
  =retrieval>
     isa         association
     type        vowel
  =imaginal>
     isa         count-from
     count       =num1
  ?retrieval>
    state        free
   ?manual>   
      state      free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state        start              ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state  increment-count    ;use the count-state slot to mark where you are in the counting
  =imaginal>
  +manual>
      ISA         punch
      hand        left 
      finger      index
)

;;;;;;;;;;;;
;reaction task consonant - react to cons, restore the count-from in the imaginal, if it isn't there at this point, and increment the count

;if the goal state of count is yes and 
;you retreived a consonant and do not have anything in the imaginal, press 0 and try if you can retrieve a count-fact from memory
(p react-yes-noimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
     id          =id         
  =retrieval>
     isa         association
     type        consonant
   ?manual>   
      state       free
  ?imaginal>
      state       free
      buffer      empty
  ?retrieval>
    state    free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    restore-count     ; use the count-state slot to mark where you are in the counting
  +retrieval>
     ISA         count-from
   +manual>
      ISA         punch
      hand        right 
      finger      index
)

;if the goal state of count is yes and 
;you retreived a consonant and have a previous-symp fact in the imaginal, press yes, and try if you can retrieve a count-fact from memory
(p react-yes-wrongimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
     id          =id         
  =retrieval>
     isa         association
     type        consonant
   ?manual>   
      state       free
  =imaginal>
     isa         previoussymptom
  ?retrieval>
    state    free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =imaginal>                         ;keep imaginal, till it is overwritten by the new content
  =goal>
     state          start            ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    restore-count    ;use the count-state slot to mark where you are in the counting
  +retrieval>
     ISA         count-from
   +manual>
      ISA         punch
      hand        right 
      finger      index
)

; if you can retrieve a count fact, restore it in the imaginal and try to retrieve an increment fact
(p restore-count-consonant
  =goal>
     ISA           react
     count-state   restore-count    ;if the count-state slot marks that you try to restore the count
  =retrieval>
      ISA         count-from
      count       =num1
  ?imaginal>
     state        free
  ?retrieval>
    state    free
==>
  !bind! =stringid (intern (format nil "~a~a" *counter* *idm*)) 
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state    increment-count    ;use the count-state slot to mark where you are in the counting
     id             =stringid               ;save the id of the count-from chunk also in the goal, so that you can use it to retrieve the right PS later
  +imaginal>
     ISA         count-from
     count       =num1 
     id          =stringid
  +retrieval>
      ISA         count-order
      first       =num1
)

;if the goal state of count is yes and 
;you retreived a consonant and you do have a count fact in the imaginal, press 0 and increment the count
(p react-yes-countimaginal
  =goal>
     ISA         react
     state       respond
     count       yes
  =retrieval>
     isa         association
     type        consonant
  =imaginal>
     isa         count-from
     count       =num1
  ?retrieval>
    state        free
   ?manual>   
      state      free
   =aural>
     isa     sound         ;this leads to emptying the aural, as soon as you reacted
==>
  =goal>
     state        start              ; state is reset to start, so that even if counting was not completed, new letters can be attended
     count-state  increment-count    ;use the count-state slot to mark where you are in the counting
  =imaginal>
  +retrieval>
      ISA         count-order
      first       =num1
   +manual>
      ISA         punch
      hand        right 
      finger      index
)

;if you retrieved an increment fact, increase the count in the imaginal (put a count from with count 1 in imaginal) and wait for next stimulus 
(P increment-count
  =goal>
     ISA         react
     count-state increment-count
   =retrieval>
      ISA         count-order
      first       =num1
      second      =num2
  =imaginal>
     isa         count-from
     count       =num1
 ==>
  =imaginal>
     count       =num2 
   =goal>
     state       start
     count-state  start    ;marks that counting was completed - added so that there are always 4 slots in the goal filled
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   enter count        ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;there is a seperate production for look at count and for lookt at stim, because this one needs to fire for the react-goal thread

;counting task (if a stimulus has been automatically stuffed in the visual-location buffer, move attention to this stimulus and set goal state to retrieve)
; only fires if the task as been set to "count", thus the diagnosis has been made
(P look-at-count
  =goal>
     ISA         react
     state       start
  =visual-location>
     ISA         visual-location
  ?visual>
     state       free
   !eval! (equalp *task* "count")
==>
  +visual>
     ISA         move-attention
     screen-pos  =visual-location
  =goal>
     state       retrieve 
)

;;;;;;;;;;;;;;;;;
;right imaginal:

;;;prepare to enter the count response
;if you have a count in the imaginal, keep it
(p prepare-count-rightimaginal
   =goal>
     ISA         react
     state       retrieve
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         count-from
==>
    !eval! (set-hand-location left 4 4)   ;put hands back to home row - F
    !eval! (set-hand-location right 7 4) ;put hands back to home row - J
  =visual>
  =imaginal>
  =goal>
     state       respond
)

;;;;;;;;;;;;;;;;;
;not the right imaginal:

;if you have no count in the imaginal, but a diagnosis fact, retrieve the count from dm
(p prepare-count-wrongimaginal
   =goal>
     ISA         react
     state       retrieve
     id           =id
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         previoussymptom
  ?retrieval>
    state    free
==>
  =imaginal>
  =visual>
  +retrieval>
     ISA         count-from
  =goal>
     state       restore-count
)

;if the imaginal is empty, restrieve the count from dm
(p prepare-count-noimaginal
   =goal>
     ISA         react
     state       retrieve
     id           =id
  =visual>
     isa         text
     value       "anzahl"
  ?imaginal>
     buffer     empty
  ?retrieval>
    state    free
==>
  =visual>
  +retrieval>
     ISA         count-from
  =goal>
     state       restore-count
)

; if you retrieve a count fact, restore it in the imaginal and prepare response
(p restore-count-react
  =goal>
     ISA         react
     state       restore-count
  =visual>
     isa         text
     value       "anzahl"
  =retrieval>
      ISA        count-from
      count      =num1
  ?imaginal>
     state       free

==>
    !bind! =stringid (intern (format nil "~a~a" *counter* *idm*)) 

    !eval! (set-hand-location left 4 4)   ;put hands back to home row - F
    !eval! (set-hand-location right 7 4) ;put hands back to home row - J
  =visual>
   =goal>
     state       respond            
     id          =stringid
   +imaginal>
     ISA         count-from
     count       =num1 
     id          =stringid
)


;;;;;;;;;;;
;enter count - the eval makes sure the 2 digit numbers are entered correctly

;enter a one digit number
(p enter-count-1digit
   =goal>
     ISA         react
     state       respond
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         count-from
     count       =num
  ?manual>
      state       free
   !eval! (< =num 10)
==>
   -imaginal>   
   -goal>
   +manual>
      ISA         press-key   
      key         =num
   +visual>
     isa clear ;just to make sure this doesn't cause a problem
)

;for 2 digit numbers, enter x, y, z -> in lisp code above this is recoded into 10,11,12
;because for entering 2 digits 2 productions would be needed which would make it unnecessarily complex, as the count rt is not in the modeling focus here

(p enter-count-10
   =goal>
     ISA         react
     state       respond
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         count-from
     count       10
  ?manual>
      state       free
==>
   -imaginal>   
   -goal>
   +manual>
      ISA         press-key   
      key         "X"
   +visual>
     isa clear ;just to make sure this doesn't cause a problem
)

(p enter-count-11
   =goal>
     ISA         react
     state       respond
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         count-from
     count       11
  ?manual>
      state       free
==>
   -imaginal>   
   -goal>
   +manual>
      ISA         press-key   
      key         "Y"
   +visual>
     isa clear ;just to make sure this doesn't cause a problem
)

(p enter-count-12
   =goal>
     ISA         react
     state       respond
  =visual>
     isa         text
     value       "anzahl"
  =imaginal>
     isa         count-from
     count       12
  ?manual>
      state       free
==>
   -imaginal>   
   -goal>
   +manual>
      ISA         press-key   
      key         "Z"
   +visual>
     isa clear ;just to make sure this doesn't cause a problem
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   DIAGNOSIS TASK                           ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;identical to JEP-model, with the addition that imaginal is recovered if it has been used for counting

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   Attend symptom            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;if a stimulus has been automatically stuffed in the visual-location buffer, move attention to this stimulus and set goal state to retrieve
(P look-at-stimulus
  =goal>
     ISA         diagnose
     state       start
  =visual-location>
     ISA         visual-location
  ?visual>
     state       free
  ?imaginal>
     state       free
==>
  +visual>
     ISA         move-attention
     screen-pos  =visual-location
  =goal>
     state       retrieve 
)

;retrieve chunk of current stimulus, if stimulus is not 'diagnosis'
(P retrieve-chunk-of-current-stimulus
  =goal>
     ISA         diagnose
     state       retrieve
  =visual>
     isa         text
     value       =text
     - value     "diagnose"
  ?retrieval>
     state       free
==>
  +retrieval>
     ISA         word
     value       =text
  =goal>
     state       encode 
)

; if you don't know the presented stimulus (can't retrieve a chunk of its meaning), set goal to start again
;shouldn't have to fire, as the model should know all the stimuli
(p dummy
  =goal>
     ISA         diagnose
     state       encode
  ?retrieval>
     state       error
==>
   =goal>
      state       start
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   encode symptoms - adapted to restore PS  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;overview of basic productions that fire in the conditions (if everything is retrieved correctly):

;;;no count:
;s1: p-encoode-current-noimaginal + p-restore-s-p0
;s2: p-encoode-current-s2-rightimagnial
;s3: p-encoode-current-s3-rightimagnial
;s4: p-encoode-current-s4-rightimagnial

;;;count:
;s1: p-encoode-current-wrongimaginal + p-restore-s-p0
;s2: p-encoode-current-wrongimaginal + p-restore-s-p1
;s3: p-encoode-current-wrongimaginal + p-restore-s-p2
;s4: p-encoode-current-wrongimaginal + p-restore-s-p3


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;encode the current symptom in the imaginal - if there is no or wrong imaginal 

;encode the retrieved symptom in the imaginal and try to retrieve if you had already observed earlier symptoms

;if imaginal is empty (because no symptoms have been observed yet and counting task doesn't use it either): 
;store the new symp in the imaginal and try to retrieve a previoussymptom chunk from dm
(P encode-current-stimulus-noimaginal
  =goal>
     ISA         diagnose
     state       encode
     id          =id
  =retrieval>
     isa         word
     value       =text
  ?imaginal>
     state       free
     buffer      empty   
==>
  +imaginal>
     ISA         previoussymptom
     s1          =retrieval      ;store the observed symptom in the imaginal
     id          =id
  +retrieval>
     isa       previoussymptom
  =goal>
     state       start
     diag-state  restore-diag
  +visual>
   isa clear
)

;if imaginal is used for counting task:  store the new symp in the imaginal and try to retrieve a previoussymptom chunk from dm
(P encode-current-stimulus-wrongimaginal
  =goal>
     ISA         diagnose
     state       encode
     id          =id
  =retrieval>
     isa         word
     value       =text
  =imaginal>
     isa         count-from  
==>
  +imaginal>
     ISA         previoussymptom
     s1          =retrieval    
     id          =id
  +retrieval>
     isa       previoussymptom
  =goal>
     state       start
     diag-state  restore-diag      ;makes sure that in the case that it can't complete the restoring, it will still be able to attend to new stimulus
  +visual>
   isa clear
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;restore problem state by adding previously observed symptoms (retrieved from dm) to the new symptom in the imaginal

;no previous symptoms
;if the previoussymptom chunk doesn't contain symptoms, simply leave the imaginal content as it is, but add an id
(p restore-symptoms-previous0
  =goal>
     ISA          diagnose
  =retrieval>
      ISA         previoussymptom
      s1          nil
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          nil
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
      id             =id               ;save the id of the count-from chunk also in the goal, so that yuo can use it to retrieve the right PS later
  =imaginal>
     s1          =s1
     id          =id
  +visual>
    isa clear
)

;1 previous symptom
;;if the previoussymptom chunk contains 1 symptom, add this to the imaginal content and add an id
(p restore-symptoms-previous1
  =goal>
     ISA           diagnose
  =retrieval>                          
      ISA         previoussymptom
      s1          =old1
      s2          nil                  
  =imaginal>
     isa         previoussymptom   
     s1          =s1
     s2          nil
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
      id             =id               ;save the id of the count-from chunk also in the goal, so that yuo can use it to retrieve the right PS later
  =imaginal>
     s1          =s1
     s2          =old1
     id          =id
  +visual>
    isa clear
)

;2 previous symptoms
(p restore-symptoms-previous2
  =goal>
     ISA           diagnose
  =retrieval>
      ISA         previoussymptom
      s1          =old1
      s2          =old2
      s3          nil
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          nil

==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
      id             =id               ;save the id of the count-from chunk also in the goal, so that yuo can use it to retrieve the right PS later
  =imaginal>
     s1          =s1
     s2          =old1
     s3          =old2
     id          =id
  +visual>
    isa clear
)


;3 previous symptoms
(p restore-symptoms-previous3
  =goal>
     ISA           diagnose
  =retrieval>
      ISA         previoussymptom
      s1          =old1
      s2          =old2
      s3          =old3
      s4          nil
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          nil

==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
      id             =id               ;save the id of the count-from chunk also in the goal, so that yuo can use it to retrieve the right PS later
  =imaginal>
     s1          =s1
     s2          =old1
     s3          =old2
     s4          =old3
     id          =id
  +visual>
    isa clear
)

;4 previous symptoms
;can only happen if model is not resest after each trial and falsly retrieves a chunk from a previous trial
;if it happens, encode the new symptom, together with the 3 most recent old ones and loose the oldest one (as there can be a max of 4 symptoms)
(p restore-symptoms-previous4
  =goal>
     ISA           diagnose
  =retrieval>
      ISA         previoussymptom
      s1          =old1
      s2          =old2
      s3          =old3
      s4          =old4
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          nil

==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
   =goal>
     state          start             ; state is reset to start, so that even if counting was not completed, new letters can be attended
      id             =id               ;save the id of the count-from chunk also in the goal, so that yuo can use it to retrieve the right PS later
  =imaginal>
     s1          =s1
     s2          =old1
     s3          =old2
     s4          =old3
     id          =id
  +visual>
    isa clear
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;right imaginal

;if previous symptoms are still stored in the imaginal, simply add new symptom (can fire if PS holds diag task)

;encode second symptom (if you retrieved a symptom-chunk, and something is in the first slot of the imaginal buffer, push that into the second slot of the imaginal and put the retrieved chunk in the first slot of the imaginal buffer) - > as in the original model
(P encode-current-stimulus2-rightimaginal
  =goal>
     ISA         diagnose
     state       encode
  =retrieval>
     isa         word
     value       =text
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          nil
==>
  =imaginal>
     s1          =retrieval       
     s2          =s1             
  =goal>
     state       start
  +visual>
    isa clear
)

;encode third symptom (if you retrieved a symptom-chunk, and something is in the first and second slot of the imaginal buffer, push that into the second / third slot of the imaginal and put the retrieved chunk in the first slot of the imaginal buffer)
(P encode-current-stimulus3-rightimaginal
  =goal>
     ISA         diagnose
     state       encode
  =retrieval>
     isa         word
     value       =text
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          =s2
     s3          nil
==>
  =imaginal>
     s1          =retrieval      
     s2          =s1             
     s3          =s2             
  =goal>
     state       start
  +visual>
    isa clear
)

;encode fourth symptom (if you retrieved a symptom-chunk, and something is in the first, second and third slot of the imaginal buffer, push that into the second / third /fourth slot of the imaginal and put the retrieved chunk in the first slot of the imaginal buffer)
(P encode-current-stimulus4-rightimaginal
  =goal>
     ISA         diagnose
     state       encode
  =retrieval>
     isa         word
     value       =text
  =imaginal>
     isa         previoussymptom
     s1          =s1
     s2          =s2
     s3          =s3
     s4          nil
==>
  =imaginal>
     s1          =retrieval      
     s2          =s1              
     s3          =s2            
     s4          =s3            
  =goal>
     state       start
  +visual>
    isa clear
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   retrieve and enter diagnosis  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;prepare to enter the diagnosis

;if you have symptoms in the imaginal, keep them
(p prepare-diag-rightimaginal
   =goal>
     ISA         diagnose
     state       retrieve
  =visual>
     isa         text
     value       "diagnose"
  =imaginal>
     isa         previoussymptom
==>
  =visual>
  =imaginal>
  =goal>
     state       retrieve-diag
)


;if you have no symptoms in the imaginal, restore them
;wrong imaginal
(p prepare-diag-wrongimaginal
   =goal>
     ISA         diagnose
     state       retrieve
     id          =id
  =visual>
     isa         text
     value       "diagnose"
  =imaginal>
     isa         count-from
  ?retrieval>
    state    free
==>
  =visual>
  +retrieval>
     ISA         previoussymptom
  =goal>
     state       restore-diag
)

;no imaginal
(p prepare-diag-noimaginal
   =goal>
     ISA         diagnose
     state       retrieve
     id          =id
  =visual>
     isa         text
     value       "diagnose"
  ?imaginal>
     buffer     empty
  ?retrieval>
    state    free
==>
  =visual>
  +retrieval>
     ISA         previoussymptom
  =goal>
     state       restore-diag
)


;;;
; restore previous-symptom chunk in the imaginal

; no symptoms in the chunk
(p restore-diag-0symptoms
  =goal>
     ISA         diagnose
     state       restore-diag
  =visual>
     isa         text
     value       "diagnose"
  =retrieval>
      ISA        previoussymptom
      s1         nil
  ?imaginal>
     state       free
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
  =visual>
   =goal>
     state       retrieve-diag           
     id          =id
   +imaginal>
      isa       previoussymptom
      s1        nil
      id        =id
)

; 1 symptom in the chunk
(p restore-diag-1symptom
  =goal>
     ISA         diagnose
     state       restore-diag
  =visual>
     isa         text
     value       "diagnose"
  =retrieval>
      ISA        previoussymptom
      s1         =s1
      s2         nil
  ?imaginal>
     state       free
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
  =visual>
   =goal>
     state       retrieve-diag         
      id        =id
   +imaginal>
      isa       previoussymptom
      s1         =s1
      s2         nil
      id        =id
)

; 2 symptoms in the chunk
(p restore-diag-2symptoms
  =goal>
     ISA         diagnose
     state       restore-diag
  =visual>
     isa         text
     value       "diagnose"
  =retrieval>
      ISA        previoussymptom
      s1         =s1
      s2         =s2
      s3         nil
  ?imaginal>
     state       free
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
  =visual>
   =goal>
     state       retrieve-diag           
      id        =id
   +imaginal>
      isa       previoussymptom
      s1         =s1
      s2         =s2
      s3         nil
      id        =id
)

; 3 symptoms in the chunk
(p restore-diag-3symptoms
  =goal>
     ISA         diagnose
     state       restore-diag
  =visual>
     isa         text
     value       "diagnose"
  =retrieval>
      ISA        previoussymptom
      s1         =s1
      s2         =s2
      s3         =s3
      s4         nil
  ?imaginal>
     state       free

==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
  =visual>
   =goal>
     state       retrieve-diag          
      id        =id
   +imaginal>
      isa       previoussymptom
      s1         =s1
      s2         =s2
      s3         =s3
      s4         nil
      id        =id
)

; 4 symptoms in the chunk
(p restore-diag-4symptoms
  =goal>
     ISA         diagnose
     state       restore-diag
  =visual>
     isa         text
     value       "diagnose"
  =retrieval>
      ISA        previoussymptom
      s1         =s1
      s2         =s2
      s3         =s3
      s4         =s4
  ?imaginal>
     state       free
==>
  !bind! =id (intern (format nil "~a~a~a" "s" *sympcounter* *idm*))   
  =visual>
   =goal>
     state       retrieve-diag    
      id        =id
   +imaginal>
      isa       previoussymptom
      s1         =s1
      s2         =s2
      s3         =s3
      s4         =s4
      id        =id
)

;;;;;;;;;;;;;;;;;;;;;;;;;
;retrieve diagnosis  

;if stimulus in the visual buffer is 'diagnosis', retrieve association-chunk with the highest activation
;can only fire if there is a previous symptom chunk in the imaginal, to make sure the symptoms get a chance to spread activation at the point of diagnosis
(p diagnosis
   =goal>
     ISA         diagnose
     state       retrieve-diag
  =visual>
     isa         text
     value       "diagnose"
  =imaginal>
     isa        previoussymptom
  ?retrieval>
     state       free
  ?manual>
      state       free
==>

    !eval! (set-hand-location left 4 4)   ;put hands back to home row - F
    !eval! (set-hand-location right 7 4)  ;put hands back to home row - J

  =imaginal>
  +retrieval>
     ISA         association
     class       chemical
  =goal>
     state       respond
)


;;;;;;;;;;;;;;;;;;;;;;;;;
;respond with diagnosis 
;if you retrieved an association chunk, type its name and empty the imaginal buffer
(p enterdiagnosis
   =goal>
      ISA         diagnose
      state       respond
   =retrieval>
      isa         association
      value       =diagnose
   ?manual>
      state       free
  =imaginal>
     isa         previoussymptom
==>
   -imaginal>   
   -goal>
   +manual>
      ISA         press-key
      key         =diagnose
   +visual>
     isa clear ;just to make sure this doesn't cause a problem
)


)